VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const LOCALE_SENGLANGUAGE = &H1001
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, ByVal cchData As Long) As Long

Private Sub Form_DblClick()
Open "c:\output.log" For Output As 1
'1. obtain object (in this sample, a running Word application)
Dim o As Object
Set o = CreateObject("Microsoft.XMLDOM")
Dim disp As olelib.IProvideClassInfo, info As olelib.ITypeInfo
Set disp = o
Set info = disp.GetClassInfo
'2. get object IID to match the coclass
Dim pta As Long, ta As TYPEATTR
pta = info.GetTypeAttr
MoveMemory ta, ByVal pta, LenB(ta)
info.ReleaseTypeAttr pta
'3. find and print the coclass
Dim Name As String, Description As String
Dim tlb As ITypeLib, index As Long
Dim pla As Long, la As TLIBATTR
index = info.GetContainingTypeLib(tlb)
tlb.GetDocumentation -1, Name, Description, 0, vbNullString
Print #1, "Type library:"
Print #1, Name, Description
pla = tlb.GetLibAttr
MoveMemory la, ByVal pla, LenB(la)
tlb.ReleaseTLibAttr pla
Dim pClsid As Long, Clsid As String
pClsid = StringFromCLSID(la.iid)
Clsid = SysAllocString(pClsid)
CoTaskMemFree pClsid
Print #1, "LibID: " & Clsid
Print #1, "Version: " & la.wMajorVerNum & "." & la.wMinorVerNum
Print #1, "Language: " & GetLocaleName(la.lcid)
If la.wLibFlags And LIBFLAG_FRESTRICTED Then Print #1, "(restricted) ";
If la.wLibFlags And LIBFLAG_FCONTROL Then Print #1, "(control) ";
If la.wLibFlags And LIBFLAG_FHIDDEN Then Print #1, "(hidden) ";
If la.wLibFlags And (LIBFLAG_FRESTRICTED Or LIBFLAG_FCONTROL Or LIBFLAG_FHIDDEN) Then Print #1,
Print #1, "=========="

PrintCoclass info, ta

Close 1
End Sub

Private Sub PrintCoclass(ByVal cls As ITypeInfo, ta As TYPEATTR)
Dim Name As String, Description As String
    Debug.Assert ta.TYPEKIND = TKIND_COCLASS
    cls.GetDocumentation DISPID_UNKNOWN, Name, Description, 0, vbNullString
    Print #1, "Coclass:"
    Print #1, Name, Description
    Dim pClsid As Long, Clsid As String
    pClsid = StringFromCLSID(ta.iid)
    Clsid = SysAllocString(pClsid)
    CoTaskMemFree pClsid
    Print #1, "CLSID: " & Clsid
    Dim pProgId As Long, ProgId As String
    pProgId = ProgIDFromCLSID(ta.iid)
    ProgId = SysAllocString(pProgId)
    CoTaskMemFree pProgId
    Print #1, "ProgID: " & ProgId
    Print #1, "Version: " & ta.wMajorVerNum & "." & ta.wMinorVerNum
    Print #1, "Language: " & GetLocaleName(ta.lcid)
    Print #1, ta.cImplTypes & " interfaces implemented"
    PrintTypeFlags ta
    Print #1, "========="

    Dim j As Long, info2 As ITypeInfo
    Dim pta3 As Long, ta3 As TYPEATTR
    For j = 0 To ta.cImplTypes - 1
        Set info2 = cls.GetRefTypeInfo(cls.GetRefTypeOfImplType(j))
        pta3 = info2.GetTypeAttr
        MoveMemory ta3, ByVal pta3, LenB(ta3)
        info2.ReleaseTypeAttr pta3
        If ta3.TYPEKIND = TKIND_DISPATCH Then
            PrintDispinterface info2, ta3, cls.GetImplTypeFlags(j)
        ElseIf ta3.TYPEKIND = TKIND_INTERFACE Then
            Print #1, "Interface:"
            PrintInterface info2, ta3, cls.GetImplTypeFlags(j)
        Else    'nothing more supported on coclass
            Stop
        End If
    Next
End Sub

Private Sub PrintDispinterface(ByVal info As ITypeInfo, ta As TYPEATTR, ByVal it As IMPLTYPE)
    Debug.Assert ta.TYPEKIND = TKIND_DISPATCH
    Print #1, "Dispinterface:"
    PrintInterface info, ta, it
    
    If (ta.wTypeFlags And TYPEFLAG_FDUAL) = 0 Then Exit Sub
    
    Dim pta As Long
    Set info = info.GetRefTypeInfo(info.GetRefTypeOfImplType(-1))
    pta = info.GetTypeAttr
    MoveMemory ta, ByVal pta, LenB(ta)
    info.ReleaseTypeAttr pta
    Debug.Assert ta.TYPEKIND = TKIND_INTERFACE
    Print #1, "VTBL-bound interface:"
    PrintInterface info, ta, &H80000000
End Sub

Private Sub PrintInterface(ByVal info As ITypeInfo, ta As TYPEATTR, ByVal it As IMPLTYPE)
Dim i As Long, j As Long
Dim Name As String, Description As String

info.GetDocumentation DISPID_UNKNOWN, Name, Description, 0, vbNullString
Print #1, Name, Description
Dim pClsid As Long, Clsid As String
pClsid = StringFromCLSID(ta.iid)
Clsid = SysAllocString(pClsid)
CoTaskMemFree pClsid
Print #1, "IID: " & Clsid
Print #1, "Version: " & ta.wMajorVerNum & "." & ta.wMinorVerNum
Print #1, "Language: " & GetLocaleName(ta.lcid)
Print #1, ta.cFuncs & " functions, " & ta.cVars & " variables" 'variables not browsed
Print #1, "Instance size: " & ta.cbSizeInstance
Print #1, "VTBL size: " & ta.cbSizeVft

Print #1, "Ancestors:"
Dim anc As ITypeInfo: Set anc = info
While Not (anc Is Nothing)
    Dim pta2 As Long, ta2 As TYPEATTR
    pta2 = anc.GetTypeAttr
    MoveMemory ta2, ByVal pta2, LenB(ta2)
    anc.ReleaseTypeAttr pta2
    If ta2.cImplTypes = 0 Then
        Set anc = Nothing
    Else
        Debug.Assert ta2.cImplTypes = 1
        Set anc = anc.GetRefTypeInfo(anc.GetRefTypeOfImplType(0))
        anc.GetDocumentation DISPID_UNKNOWN, Name, Description, 0, vbNullString
        Print #1, , Name, Description
    End If
Wend

If it And IMPLTYPEFLAG_FDEFAULT Then Print #1, "(default) ";
If it And IMPLTYPEFLAG_FSOURCE Then Print #1, "(events) ";
If it And IMPLTYPEFLAG_FRESTRICTED Then Print #1, "(restricted impl) ";
If it And IMPLTYPEFLAG_FDEFAULTVTABLE Then Stop 'What does it mean, at last?
If it And &H80000000 Then Print #1, "(dual back-end) ";
PrintTypeFlags ta

Print #1, "=========="

For i = 0 To ta.cFuncs - 1
    Dim pfd As Long, fd As FUNCDESC
    Dim Names() As String, Params() As ELEMDESC
    
    pfd = info.GetFuncDesc(i)
    MoveMemory fd, ByVal pfd, LenB(fd)
    ReDim Names(1 To fd.cParams + 1)
    If fd.cParams > 0 Then
        ReDim Params(1 To fd.cParams)
        MoveMemory Params(1), ByVal fd.lprgELEMDESCParam, fd.cParams * LenB(Params(1))
    End If
    
    info.GetDocumentation fd.memid, Name, Description, 0, vbNullString
    Print #1, Name, Description
    
    Select Case fd.invkind
    Case INVOKE_FUNC:
        If it And IMPLTYPEFLAG_FSOURCE Then
            Print #1, "Event ";
        ElseIf fd.elemdescFunc.tdesc.vt <> VT_VOID Then
            Print #1, "Function ";
        Else
            Print #1, "Sub ";
        End If
    Case INVOKE_PROPERTYGET: Print #1, "Property Get ";
    Case INVOKE_PROPERTYPUT: Print #1, "Property Let ";
    Case INVOKE_PROPERTYPUTREF: Print #1, "Property Set ";
    End Select
    j = info.GetNames(fd.memid, Names(1), UBound(Names))
    If j <> UBound(Names) Then
        Debug.Assert (fd.invkind = INVOKE_PROPERTYPUT) Or (fd.invkind = INVOKE_PROPERTYPUTREF)
        Debug.Assert j = UBound(Names) - 1
        Names(UBound(Names)) = "RHS"
    End If
    
    For j = 1 To UBound(Names)
        If j > 1 Then
            If Params(j - 1).PARAMDESC.wParamFlags And (PARAMFLAG_FIN Or PARAMFLAG_FOUT Or PARAMFLAG_FRETVAL) Then
                Dim pflags As String: pflags = vbNullString
                Print #1, "[";
                If Params(j - 1).PARAMDESC.wParamFlags And PARAMFLAG_FIN Then pflags = pflags & "in, "
                If Params(j - 1).PARAMDESC.wParamFlags And PARAMFLAG_FOUT Then pflags = pflags & "out, "
                If Params(j - 1).PARAMDESC.wParamFlags And PARAMFLAG_FRETVAL Then pflags = pflags & "retval, "
                Print #1, Left(pflags, Len(pflags) - 2) & "] ";
            End If
            If (Params(j - 1).PARAMDESC.wParamFlags And PARAMFLAG_FOPT) Or (j > (UBound(Names) - fd.cParamsOpt)) Then
                Print #1, "Optional ";
            End If
            If (Params(j - 1).tdesc.vt And VT_TYPEMASK) <> VT_PTR Then
                Print #1, "ByVal ";
            End If
            If fd.cParamsOpt = -1 Then
                If j = UBound(Names) Then
                    If (Params(j - 1).PARAMDESC.wParamFlags And PARAMFLAG_FRETVAL) = 0 Then _
                        Print #1, "ParamArray ";
                Else
                    If Params(j).PARAMDESC.wParamFlags And PARAMFLAG_FRETVAL Then _
                        Print #1, "ParamArray ";
                End If
            End If
        End If
        Print #1, Names(j);
        If j = 1 Then
            Print #1, "(";
        Else
            Print #1, " As ";
            PrintType info, Params(j - 1).tdesc
            If Params(j - 1).PARAMDESC.wParamFlags And PARAMFLAG_FOPT Then
                If Params(j - 1).PARAMDESC.wParamFlags And PARAMFLAG_FHASDEFAULT Then
                    Dim pdx As PARAMDESCEX
                    MoveMemory pdx, ByVal Params(j - 1).PARAMDESC.pPARAMDESCEX, LenB(pdx)
                    Print #1, " = " & ToStr(pdx.varDefaultValue);
                End If
            End If
            If j < UBound(Names) Then
                Print #1, ", ";
            End If
        End If
    Next
    Print #1, ")";
    If fd.elemdescFunc.tdesc.vt <> VT_VOID Then
        Print #1, " As ";
        PrintType info, fd.elemdescFunc.tdesc
    End If
    Print #1,
    
    If fd.wFuncFlags And FUNCFLAG_FRESTRICTED Then Print #1, "(restricted) ";
    If fd.wFuncFlags And FUNCFLAG_FUIDEFAULT Then Print #1, "(default) ";
    If fd.wFuncFlags And FUNCFLAG_FHIDDEN Then Print #1, "(hidden) ";
    If fd.wFuncFlags And FUNCFLAG_FDEFAULTCOLLELEM Then Print #1, "(default !-function) ";
    If fd.wFuncFlags And FUNCFLAG_FNONBROWSABLE Then Print #1, "(non-browsable) ";
    Select Case fd.FUNCKIND
    Case FUNC_PUREVIRTUAL: Print #1, "(abstract @" & fd.oVft & ")"
    Case FUNC_VIRTUAL: Print #1, "(virtual @" & fd.oVft & ")"
    Case FUNC_NONVIRTUAL: Print #1, "(static)"
    Case FUNC_STATIC: 'not a member function
    Case FUNC_DISPATCH: Print #1, "(dispatch @" & fd.memid & ")"
    End Select
    Print #1, "----------"
    info.ReleaseFuncDesc pfd
Next
End Sub

Private Sub PrintType(ByVal info As ITypeInfo, tdesc As TYPEDESC)
Dim info2 As ITypeInfo, tdesc2 As TYPEDESC
Dim Name As String, Description As String
    Select Case tdesc.vt And VT_TYPEMASK
    Case vbEmpty:       Print #1, "<Empty>";
    Case vbNull:        Print #1, "<Null>";
    Case vbInteger:     Print #1, "Integer";
    Case vbLong:        Print #1, "Long";
    Case vbSingle:      Print #1, "Single";
    Case vbDouble:      Print #1, "Double";
    Case vbCurrency:    Print #1, "Currency";
    Case vbDate:        Print #1, "Date";
    Case vbString:      Print #1, "String";
    Case vbObject:      Print #1, "Object";
    Case vbError:       Print #1, "<Error>";
    Case vbBoolean:     Print #1, "Boolean";
    Case vbVariant:     Print #1, "Variant";
    Case vbDataObject:  Print #1, "DataObject";
    Case vbDecimal:     Print #1, "Decimal";
    Case vbByte:        Print #1, "Byte";
    Case vbUserDefinedType: Print #1, "UDT";
    Case VT_PTR:
        MoveMemory tdesc2, ByVal tdesc.pTypeDesc, LenB(tdesc2)
        PrintType info, tdesc2
    Case VT_SAFEARRAY:
        MoveMemory tdesc2, ByVal tdesc.pTypeDesc, LenB(tdesc2)
        PrintType info, tdesc2
        Print #1, "()";
    Case VT_USERDEFINED:
        Set info2 = info.GetRefTypeInfo(tdesc.pTypeDesc)
        info2.GetDocumentation DISPID_UNKNOWN, Name, Description, 0, vbNullString
        Print #1, Name;
    Case VT_VOID:
        Print #1, "Any"; 'only used in void* Param, never in void* Param
    Case VT_I1:         Print #1, "<CHAR>";
    Case VT_I8:         Print #1, "<INT64>";
    Case VT_INT:        Print #1, "<INT>";
    Case VT_UI2:        Print #1, "<USHORT>";
    Case VT_UI4:        Print #1, "<ULONG>";
    Case VT_UI8:        Print #1, "<UINT64>";
    Case VT_UINT:       Print #1, "<UINT>";
    Case VT_HRESULT:    Print #1, "<HRESULT>";
    Case Else: Stop
    End Select
    If tdesc.vt And vbArray Then
        Print #1, "()";
    End If
    If tdesc.vt And VT_BYREF Then Stop 'never seen this anywhere
End Sub

Private Sub PrintTypeFlags(ta As TYPEATTR)
If ta.wTypeFlags And TYPEFLAG_FAPPOBJECT Then Print #1, "(app object) ";
If (ta.wTypeFlags And TYPEFLAG_FCANCREATE) = 0 Then Print #1, "(noncreatable) ";
If ta.wTypeFlags And TYPEFLAG_FLICENSED Then Print #1, "(licensed) ";
If ta.wTypeFlags And TYPEFLAG_FPREDECLID Then Print #1, "(global) ";
If ta.wTypeFlags And TYPEFLAG_FHIDDEN Then Print #1, "(hidden) ";
If ta.wTypeFlags And TYPEFLAG_FCONTROL Then Print #1, "(control) ";
If ta.wTypeFlags And TYPEFLAG_FDUAL Then Print #1, "(dual) ";
If ta.wTypeFlags And TYPEFLAG_FNONEXTENSIBLE Then Print #1, "(nonextensible) ";
If ta.wTypeFlags And TYPEFLAG_FRESTRICTED Then Print #1, "(restricted intf) ";
Print #1,
End Sub

Private Function GetLocaleName(ByVal lcid As Long) As String
Dim Result As String * 256
GetLocaleName = Left$(Result, GetLocaleInfo(lcid, LOCALE_SENGLANGUAGE, Result, 256))
End Function

Private Function ToStr(ByVal v As Variant) As String
On Error Resume Next
ToStr = v
End Function
